__author__ = 'Yunsheng Li'
import sys, os, argparse, time
import numpy as np
from mofa import *
def parse_cmd(argv):
    parser = argparse.ArgumentParser(description='train mfa with mofa.')
    parser.add_argument('-patch_size', action="store", type=int, default='160',   help="patch size")
    parser.add_argument('-P', action="store", type=int, default='500', help="pca component")
    parser.add_argument('-M', action="store", type=int, default='50',   help="GMM component") 
    parser.add_argument('-K', action="store", type=int, default='10',   help="Hidden variable")    
    parser.add_argument('-Bin', action="store", type=bool, default = False, help="Binary or not")
    parser.add_argument('-Psis', action="store", type=bool, default = False, help="Psis(Phi) true or not")
    parser.add_argument('-init_ppca', action="store", type=bool, default = False, help="init_ppca true or not")
    parser.add_argument('-init_gmm', action="store", type=bool, default = False, help="init_gmm true or not")
    parser.add_argument('-filter_size', action="store", type=int, default='3', help="filter size")
    parser.add_argument('-Norm', action="store", type=bool, default = False, help="norm or not")
    parser.add_argument('-FCN', action="store", type=bool, default = False, help="fully convolutional neural network or not")
    parser.add_argument('-Def', action="store", type=bool, default = False, help="def-pooling layer or not")
    parser.add_argument('-Roi', action="store", type=bool, default = False, help="soft screen or not")
    args = parser.parse_args(argv[1:])
    return args 
args = parse_cmd(sys.argv)
print args
image_size = 256*256 / args.patch_size
if image_size % 32 != 0:
    image_size = (image_size / 32 + 1)*32
path == '/path/to/the/features'
features = np.load(path)
start = time.time()
mix = Mofa(features, args.M, args.K, lock_psis = args.Psis, PPCA = True, init_ppca =args.init_ppca)
end = time.time()
print 'finish initilizting mofa with %4f minutes' %((end - start) / 60)
mix.run_em(tol=1e-4, image_size=image_size)
end = time.time()
print 'finish trainging mofa with %4f minutes' %((end - start) / 60)
